//-----------------------------------------
//toTray
//    
//
//  TXT
//  NET
//  BAR
//  SEE (MousePOS)
//
//Author:   
//E-mail: raxp@mail.zp.ua
//C : not
//-----------------------------------------

unit to_tray;

interface

uses windows,SysUtils,Types,Graphics,shellapi,forms,mmsystem;

 procedure txt_tray(ch:thandle;st,st2:string);
 procedure bar_tray(ch:thandle;u1,u2:smallint;c1,c2,fon:tcolor;hint:shortstring);
 procedure see_tray(ch:thandle;hint:shortstring);
 procedure delicon(ch:thandle);

 procedure _net(h:thandle);
 procedure _ram(h:thandle);

 procedure set_tn(ti,r: smallint; hint:shortstring);
 procedure show_tn(mode: smallint; info,title: string);

//
const
 NIF_INFO = $10;
 NIF_MESSAGE = 1;
 NIF_ICON = 2;
 NOTIFYICON_VERSION = 3;
 NIF_TIP = 4;
 NIM_SETVERSION = $00000004;
 NIM_SETFOCUS = $00000003;
 NIIF_NONE = $00000000;
 NIIF_INFO = $00000001;
 NIIF_WARNING = $00000002;
 NIIF_ERROR = $00000003;

 WM_USER = $0400;
 NIN_BALLOONCLOSE = WM_USER + 1;
 NIN_BALLOONSHOW = WM_USER + 2;
 NIN_BALLOONHIDE = WM_USER + 3;
 NIN_BALLOONTIMEOUT = WM_USER + 4;
 NIN_BALLOONUSERCLICK = WM_USER + 5;
 NIN_SELECT = WM_USER + 0;
 NINF_KEY = $1;
 NIN_KEYSELECT = NIN_SELECT or NINF_KEY;

 TRAY_CALLBACK = WM_USER + 222;
type
 PNewNotifyIconData = ^TNewNotifyIconData;
 TDUMMYUNIONNAME    = record
 case Integer of
  0: (uTimeout: UINT);
  1: (uVersion: UINT);
end;
 TNewNotifyIconData = record
   cbSize: DWORD;
   Wnd: HWND;
   uID: UINT;
   uFlags: UINT;
   uCallbackMessage: UINT;
   hIcon: HICON;
  //Version 5.0 is 128 chars, old ver is 64 chars
   szTip: array [0..127] of Char;
   dwState: DWORD; //Version 5.0
   dwStateMask: DWORD; //Version 5.0
   szInfo: array [0..255] of Char; //Version 5.0
   DUMMYUNIONNAME: TDUMMYUNIONNAME;
   szInfoTitle: array [0..63] of Char; //Version 5.0
   dwInfoFlags: DWORD;   //Version 5.0
end;

var //  traygraph
    minc:integer;
    mi,mo:array[0..31]of real;
    newvi,newvo,oldvo,oldvi:real;
    t: tpoint;
    //
    IconData: TNewNotifyIconData;
    WM_TASKBARCREATED:Cardinal;
    //-
    tmr1:integer;
    itn: smallint;
    atn: boolean;

implementation
uses unit1;
{$R res\pn.RES}
//{$R res\cur.res}

type //a 
  TMibIfRow = packed record
    wszName            : array[0..255] of WideChar;
    dwIndex,dwType,dwMtu,
    dwSpeed,dwPhysAddrLen: integer;
    bPhysAddr          : array[0..7] of Byte;
    dwAdminStatus,dwOperStatus,dwLastChange,dwInOctets,
    dwInUcastPkts,dwInNUCastPkts,dwInDiscards,
    dwInErrors,dwInUnknownProtos,dwOutOctets,dwOutUCastPkts,
    dwOutNUCastPkts,dwOutDiscards,dwOutErrors,dwOutQLen,
    dwDescrLen         : integer;
    bDescr             : array[0..255] of Char;
  end;
  TMibIfArray = array [0..512] of TMibIfRow;
  PMibIfRow = ^TMibIfRow;
  PMibIfArray = ^TMibIfArray;

type
 TMibIfTable = packed record
   dwNumEntries: integer;
   Table       : TMibIfArray;
 end;
 PMibIfTable = ^TMibIfTable;
var GetIfTable:function(pIfTable: PMibIfTable;
                        pdwSize : pulong;
                        bOrder  : Boolean ): DWORD; stdcall;
//======================

// TXT-
procedure txt_tray(ch:thandle; st,st2:string);
var memDC: HDC;
    bmp  : HBITMAP;
    oldObj: HGDIOBJ;
    rect : TRect;
    size : TSize;
    infoHeaderSize: DWORD;
    imageSize : DWORD;
    infoHeader: PBitmapInfo;
    oldFont: HFONT;
    no: TNotifyIconData;
    Icon : TIcon;
    Hicon1: HIcon;
    IconInfo:TIconInfo;
    //
    fh : hfont;
    ch2: hdc;
begin
 fh:= CreateFont(14,0,0,0,0,0,0,0,0,0,0,0,0,PChar('arial cyr'));
 memDC:= CreateCompatibleDC(0);
 ch2:= memDC;
 try
  bmp:=CreateCompatibleBitmap(ch2,16,16);
  try
   oldObj:= SelectObject(memDC,bmp);
   try
    rect.Left:= 0;
    rect.top := 0;
    rect.Right := 16;
    rect.Bottom:= 16;
    SetTextColor(memDC, RGB(255, 0, 0));
    SetBkColor(memDC, RGB(128, 128, 128));
    oldFont:= SelectObject(memDC,fh);
    GetTextExtentPoint32(memDC, PChar(st), Length(st), size);
    ExtTextOut(memDC, (rect.Right - size.cx) div 2, (rect.Bottom - size.cy) div 2, ETO_OPAQUE, @rect, PChar (st), Length (st), Nil);
    SelectObject(memDC, oldFont);
    GDIFlush;

    GetDibSizes(bmp, infoHeaderSize, imageSize);
    GetMem(infoHeader, infoHeaderSize + ImageSize);
    try
     //
     Icon             := TIcon.Create;
     IconInfo.fIcon   := true;
     IconInfo.xHotspot:= 0;
     IconInfo.yHotspot:= 0;
     IconInfo.hbmMask := bmp;
     IconInfo.hbmColor:= bmp;
     Icon.Handle:= CreateIconIndirect(IconInfo);
     //Tray
     HIcon1:=icon.handle;
     with no do
      begin
       cbSize:=Sizeof(TNotifyIconData);
       Wnd:=ch;
       uID:=0;
       UFlags:=NIF_MESSAGE+NIF_ICON+NIF_TIP;
       //hint
       StrPLCopy(szTip,st2,SizeOf(szTip)-1);
       HIcon:=HIcon1;
       uCallBackMessage:= TRAY_CALLBACK
      end;
     Shell_NotifyIcon(NIM_ADD,@no);
     Shell_NotifyIcon(NIM_MODIFY,@no);
     Icon.Free;
     //
    finally FreeMem(infoHeader) end
   finally SelectObject(memDC, oldOBJ) end
  finally DeleteObject(bmp) end
 finally DeleteDC (memDC) end
end;
//=======


//=======
// -
procedure traygraph(ch:thandle;u1,u2:real;c1,c2,fon:tcolor;hint:shortstring);
var no: TNotifyIconData;
    Hicon1: HIcon;
    //
    IconSizeX,IconSizeY,x,y:integer;
    maxi,maxo:real;
    AndMask : TBitmap;
    XOrMask : TBitmap;
    IconInfo: TIconInfo;
    Icon: TIcon;
begin
 //
 IconSizeX:= GetSystemMetrics(SM_CXICON);
 IconSizeY:= GetSystemMetrics(SM_CYICON);
 //Create "And" mask
 andMask:= TBitmap.Create;
 AndMask.Monochrome:= true;
 AndMask.Width := IconSizeX;
 AndMask.Height:= IconSizeY;
 //Draw "And" mask
 AndMask.Canvas.Brush.Color:= fon;
 AndMask.Canvas.Rectangle(0,0,IconSizeX,IconSizey);
 //
 XOrMask:= TBitmap.Create;
 XOrMask.Width := IconSizeX;
 XOrMask.Height:= IconSizeY;
 XOrMask.Canvas.Brush.Color:= fon;
 XOrMask.Canvas.FillRect(Rect(0, 0, IconSizeX, IconSizeY));

 //-1 (/)
 inc(minc);if minc=1 then for x:=0 to 31 do begin mi[x]:=1;mo[x]:=1;end;
 //
 y:=0;
 //maximum
 maxo:=u2;mo[0]:=u2;maxi:=u1;mi[0]:=u1;
 for x:=0 to 30 do begin
  if mo[x+1]>maxo then maxo:=mo[x+1];
  if mi[x+1]>maxi then maxi:=mi[x+1];
 end;
 for x:=0 to 31 do begin
  if (maxo<>0)then try mo[x]:= trunc(31*mo[x]/maxo);except end;
  if (maxi>0)then try mi[x] := trunc(30*mi[x]/maxi);except end;
 end;
 //
 for x:=0 to 31 do begin
  XOrMask.Canvas.Pen.Color  := c2;
  XOrMask.Canvas.Brush.Color:= c2;
  XOrMask.Canvas.MoveTo(32-x,32);
  XOrMask.Canvas.LineTo(32-x,32-trunc(mo[x]));
  y:= y+trunc(mi[x]);
  //
  XOrMask.Canvas.Pen.Color  := c1;
  XOrMask.Canvas.Brush.Color:= c1;
  XOrMask.Canvas.MoveTo(32-x,32);
  XOrMask.Canvas.LineTo(32-x,32-trunc(mi[x]));
 end;
 // 
 y:=trunc(y/32);
 XOrMask.Canvas.Pen.Color  :=c1;
 XOrMask.Canvas.Brush.Color:=c1;
 XOrMask.Canvas.MoveTo(1,32-y);
 XOrMask.Canvas.LineTo(32,32-y);
 //
 for x:=31 downto 1 do
  begin mi[x]:=mi[x-1];mo[x]:=mo[x-1];end;

 //
 Icon:= TIcon.Create;
 IconInfo.fIcon   := true;
 IconInfo.xHotspot:= 0;
 IconInfo.yHotspot:= 0;
 IconInfo.hbmMask := AndMask.Handle;
 IconInfo.hbmColor:= XOrMask.Handle;
 Icon.Handle      := CreateIconIndirect(IconInfo);
 AndMask.Free;
 XOrMask.Free;

 //tray
 HIcon1:=icon.Handle;
 with no do begin
  cbSize:=Sizeof(TNotifyIconData);
  Wnd:=ch;
  uID:=0;
  UFlags:=NIF_MESSAGE+NIF_ICON+NIF_TIP;
  //hint
  StrPLCopy(szTip,hint,SizeOf(szTip)-1);
  HIcon:=HIcon1;
  uCallBackMessage:= TRAY_CALLBACK
 end;
 Shell_NotifyIcon(NIM_ADD,@no);
 Shell_NotifyIcon(NIM_MODIFY,@no);
 Icon.Free
end;
//
procedure _net(h:thandle);
//   "" 
{type TMAC = array [0..7] of Byte;
function GetMAC(Value: TMAC; Length: DWORD): string;
var i:Integer;
begin
 if Length= 0 then Result:= '00-00-00-00-00-00' else
  begin
   Result:= '';
    for i:= 0 to Length -2 do
     Result:= Result + IntToHex(Value[i],2)+'-';
     Result:= Result + IntToHex(Value[Length-1],2);
  end;
end;}
// 
var FLibHandle: THandle;
    Table: TMibIfTable;
    i,k,Size:integer;
    fm,pin,pout:shortstring;
    vi,vo:real;
begin
 FLibHandle:= LoadLibrary('IPHLPAPI.DLL');
 if FLibHandle= 0 then Exit;
 @GetIfTable:= GetProcAddress(FLibHandle, 'GetIfTable');
 if not Assigned(GetIfTable) then FreeLibrary(FLibHandle);
 //
 Size:= SizeOf(Table);
 if GetIfTable(@Table, @Size,false ) = 0 then //
  for i:= 0 to Table.dwNumEntries-1 do begin

   // 
   newvi:= table.Table[0].dwInOctets;newvo:=Table.Table[0].dwOutOctets;
   //
   if (newvi/(1024*1024))>1 then begin fm:=' MB';k:=1024;end else begin fm:=' kB';k:=1;end;
    pin := 'inp  -'+ formatfloat(' 000.0',newvi/1024/k);
    pout:= 'out -' + formatfloat(' 000.0',newvo/1024/k);
    // c
    vi:=(newvi-oldvi)*10/(2*1024);
    //-
    vo:=(newvo-oldvo)*10/(2*1024);
   // 
   traygraph(h,vi,vo,cllime,clred,clteal,copy(string(Table.Table[0].bDescr),1,25)+chr(13)+
    pin+fm+chr(13)+pout+fm//+chr(13)+'C: '+inttostr(table.Table[0].dwSpeed div 1000000)+' M/c'
    );
   //
  end;
 FreeLibrary(FLibHandle);
 oldvi:= newvi;oldvo:= newvo
end;
//=======


//=======
// BAR-
procedure bar_tray(ch:thandle;u1,u2:smallint;c1,c2,fon:tcolor;hint:shortstring);
var no: TNotifyIconData;
    Hicon1: HIcon;
    //
    rect: TRect;
    IconSizeX: integer;
    IconSizeY: integer;
    AndMask  : TBitmap;
    XOrMask  : TBitmap;
    IconInfo : TIconInfo;
    Icon: TIcon;
begin
 //
 IconSizeX:= GetSystemMetrics(SM_CXICON);
 IconSizeY:= GetSystemMetrics(SM_CYICON);
 //Create "And" mask
 andMask:= TBitmap.Create;
 AndMask.Monochrome:= true;
 AndMask.Width := IconSizeX;
 AndMask.Height:= IconSizeY;
 //Draw "And" mask
 rect.Left := 0;         rect.top   := 0;
 rect.Right:= IconSizeX; rect.Bottom:= IconSizeY;
 AndMask.Canvas.FillRect(rect);
 AndMask.Canvas.Brush.Color := fon;
 AndMask.Canvas.Rectangle(0,0,IconSizeX,IconSizey);

 //
 XOrMask:= TBitmap.Create;
 XOrMask.Width := IconSizeX;
 XOrMask.Height:= IconSizeY;
 XOrMask.Canvas.Brush.Color:= fon;
 XOrMask.Canvas.FillRect(Rect);

 //-1
 XOrMask.Canvas.Pen.Color  := c1;
 XOrMask.Canvas.Brush.Color:= c1;
 XOrMask.Canvas.Rectangle(2,32-u1,IconSizeX-16,IconSizey);
 //-2
 XOrMask.Canvas.Pen.Color  := c2;
 XOrMask.Canvas.Brush.Color:= c2;
 XOrMask.Canvas.Rectangle(18,32-u2,IconSizeX,IconSizey);

 //
 Icon:= TIcon.Create;
 IconInfo.fIcon   := true;
 IconInfo.xHotspot:= 0;
 IconInfo.yHotspot:= 0;
 IconInfo.hbmMask := AndMask.Handle;
 IconInfo.hbmColor:= XOrMask.Handle;
 Icon.Handle:= CreateIconIndirect(IconInfo);
 AndMask.Free;
 XOrMask.Free;

 //Tray
 HIcon1:= icon.Handle;
 with no do begin
  cbSize:=Sizeof(TNotifyIconData);
  Wnd:=ch;
  uID:=0;
  UFlags:=NIF_MESSAGE+NIF_ICON+NIF_TIP;
  //hint
  StrPLCopy(szTip,hint,SizeOf(szTip)-1);
  //
  HIcon:=HIcon1;
  uCallBackMessage:= TRAY_CALLBACK
 end;
 Shell_NotifyIcon(NIM_ADD,@no);
 Shell_NotifyIcon(NIM_MODIFY,@no);
 //
 Icon.Free
end;
//=======


//=======
// MousePOS-
procedure see_tray(ch:thandle;hint:shortstring);

 function ArcTan2(const y,x: Extended): Extended;
 asm
  FLD y
  FLD x
  FPATAN
  FWAIT
 end;
 function ArcSin(const X: Extended): Extended;
 begin
  Result:= ArcTan2(x,sqrt(1 -x*x))
 end;

var no: TNotifyIconData;
    Hicon1: HIcon;
    //
    rect: TRect;
    IconSizeX,IconSizeY: integer;
    AndMask  : TBitmap;
    XOrMask  : TBitmap;
    IconInfo : TIconInfo;
    Icon: TIcon;
    //
    ug,a,b,w,h: integer; c: extended;
    c1,fon:tcolor;
begin
 w:= 1024; h:= 768;
 c1:= $0; fon:= $0;

 //
 IconSizeX:= GetSystemMetrics(SM_CXICON);
 IconSizeY:= GetSystemMetrics(SM_CYICON);
 //Create "And" mask
 andMask := TBitmap.Create;
 AndMask.Monochrome:= true;
 AndMask.Width := IconSizeX;
 AndMask.Height:= IconSizeY;
 //Draw "And" mask
 rect.Left := 0;         rect.top   := 0;
 rect.Right:= IconSizeX; rect.Bottom:= IconSizeY;
 AndMask.Canvas.FillRect(rect);
 AndMask.Canvas.Brush.Color:= fon;
 AndMask.Canvas.Rectangle(0,0,IconSizeX,IconSizey);

 //
 XOrMask:= TBitmap.Create;
 XOrMask.Width := IconSizeX;
 XOrMask.Height:= IconSizeY;
 XOrMask.Canvas.Brush.Color:= fon;
 XOrMask.Canvas.FillRect(Rect);

 // -
 getcursorpos(t);
 a:= h - t.Y;
 b:= w - t.X;
 c:= sqrt((a*a)+(b*b));
 ug:= 270 + trunc(180*ArcSin(a/c)/pi);
 //-1
 XOrMask.Canvas.Pen.Color  := $f0;
 XOrMask.Canvas.Brush.Color:= $f0;
 XOrMask.Canvas.MoveTo(16,16);
 XOrMask.Canvas.LineTo(16+trunc(16*sin(ug*pi/180)),16-trunc(16*cos(ug*pi/180)));

 //
 Icon:= TIcon.Create;
 IconInfo.fIcon   := true;
 IconInfo.xHotspot:= 0;
 IconInfo.yHotspot:= 0;
 IconInfo.hbmMask := AndMask.Handle;
 IconInfo.hbmColor:= XOrMask.Handle;
 Icon.Handle:= CreateIconIndirect(IconInfo);
 AndMask.Free;
 XOrMask.Free;

 //Tray
 HIcon1:= icon.Handle;
 with no do begin
  cbSize:=Sizeof(TNotifyIconData);
  Wnd:=ch;
  uID:=0;
  UFlags:=NIF_MESSAGE+NIF_ICON+NIF_TIP;
  //hint
  StrPLCopy(szTip,hint,SizeOf(szTip)-1);
  //
  HIcon:=HIcon1;
  uCallBackMessage:= TRAY_CALLBACK
 end;
 Shell_NotifyIcon(NIM_ADD,@no);
 Shell_NotifyIcon(NIM_MODIFY,@no);
 //
 Icon.Free
end;
//=======


//=======
// -
procedure delicon(ch:thandle);
var no:TNotifyIconData;
begin
 with no do begin
  cbSize:=Sizeof(TNotifyIconData);
  Wnd:=ch;
  uID:=0;
 end;
 Shell_NotifyIcon(NIM_Delete,@no)
end;
//=======


//=======
//RAM-
procedure _ram(h:thandle);
var MS:TMemoryStatus;
    vfiles,vrams:string;
    vfile,vram:integer;
begin
 GlobalMemoryStatus(MS);
 with MS do begin
  vram:=100-trunc(dwAvailPhys/dwTotalPhys*100);
  vrams:='RAM [Mb]= '+formatfloat('000.0',(dwTotalPhys-dwAvailPhys)/1024/1024)+
   '  '+formatfloat('',round(dwTotalPhys/1024/1024)+1);
  // -
  vfile:=100-trunc(dwAvailPageFile/dwTotalPageFile*100);
  vfiles:='FAM [Mb]= '+formatfloat('000.0',(dwTotalPageFile-dwAvailPageFile)/1024/1024)+
   '  '+formatfloat('',round(dwTotalPageFile/1024/1024)+1)
 end;
 //
 bar_tray(h,trunc(vram*32/100),trunc(vfile*32/100),clyellow,clred,clteal,
  '-> :'#13+vrams+chr(13)+vfiles)
end;
//=======

//=======
//   + hint
procedure Ontmr1(uTimerID, uMessage: uint;dwUser, dw1, dw2: dword) stdcall;
begin
 inc(itn); if itn>1 then itn:= 0;
 if atn then set_tn(itn,1,'')
end;
procedure set_tn(ti,r: smallint; hint:shortstring);
begin
 IconData.cbSize:= SizeOf(IconData);
 IconData.Wnd   := form1.Handle; //AllocateHWnd(vid.iconmsg);
 //
 IconData.uID   := 1;
 IconData.uFlags:= NIF_ICON or NIF_MESSAGE or NIF_TIP;
 IconData.uCallbackMessage:= TRAY_CALLBACK;
 case ti of
  0: IconData.hIcon:= loadicon(HInstance,'pn');
  1: IconData.hIcon:= loadicon(HInstance,'pw');
  2: IconData.hIcon:= loadIcon(0,MakeIntResource(32513+0));
  3: IconData.hIcon:= loadIcon(0,MakeIntResource(32513+1));
  4: IconData.hIcon:= loadIcon(0,MakeIntResource(32513+2));
  5: IconData.hIcon:= loadIcon(0,MakeIntResource(32513+3));
 end;
 StrPLCopy(IconData.szTip,hint,SizeOf(IconData.szTip)-1);
 if r=0 then begin                                   //-add
  Shell_NotifyIcon(NIM_ADD, @IconData);
  tmr1:= timesetevent(250,0,@Ontmr1,0,TIME_PERIODIC)
 end;
 if r=1 then Shell_NotifyIcon(NIM_MODIFY, @IconData);//-mod
 if r=2 then begin                                   //-del
  timeKillEvent(tmr1);
  //DeallocateHWnd(IconData.Wnd);
  Shell_NotifyIcon(NIM_DELETE, @IconData)
 end
end;
procedure show_tn(mode: smallint; info,title: string);
begin
 IconData.cbSize:= SizeOf(IconData);
 IconData.uFlags:= NIF_INFO;
 strPLCopy(IconData.szInfo, Info, SizeOf(IconData.szInfo) - 1);
 IconData.DUMMYUNIONNAME.uTimeout := 5000;
 strPLCopy(IconData.szInfoTitle, Title, SizeOf(IconData.szInfoTitle) - 1);
 case mode of
  0: IconData.dwInfoFlags:= NIIF_NONE;
  1: IconData.dwInfoFlags:= NIIF_INFO;
  2: IconData.dwInfoFlags:= NIIF_ERROR;
  3: IconData.dwInfoFlags:= NIIF_WARNING;
 end;
 Shell_NotifyIcon(NIM_MODIFY, @IconData);
 //IconData.DUMMYUNIONNAME.uVersion:= NOTIFYICON_VERSION;
 //Shell_NotifyIcon(NIM_SETVERSION, @IconData)
end;
initialization
WM_TASKBARCREATED:= RegisterWindowMessage('TaskbarCreated');
//=======

end.
